/*
 * This file specifies whole configuration of sitegin.
 * In future it might actually read configuration files but for now - if you
 * want to configure sitegin you have to modify this file.
 * (or write config reader which would replace this file - I'd appreciate
 * merge request for this feature ;) )
 */
var Git = require('nodegit');
var cli = require('cli');
var options = cli.parse({
 noserver: ['n', 'Dont run server'],
 port: ['p', 'Port on which server should run', 'number', 1337],
 uiport: [null, 'BrowserSync UI port', 'number', 'port+1'],
 httpsonly: [null, 'Converts all http://ok1kvk.cz links to https'],
 httponly: [null, 'Converts all https://ok1kvk.cz links to http'],
 contentdir: [null, 'Allows to specify arbitrary content directory.', 'string', 'content'],
 themedir: [null, 'Allows to specify arbitrary content directory.', 'string', 'theme'],
 builddir: [null, 'Allows to specify arbitrary content directory.', 'string', null],
 staticdir: [null, 'Allows to specify arbitrary directory for static files.', 'string', 'static']
});

module.exports = function() {
  console.log('Build step: Config');
  var builddir = 'build';
  if(options.builddir)
    builddir = options.builddir;
  else if(!options.noserver) builddir = 'build-debug';

  if(options.uiport == 'port+1') {
    options.uiport = options.port+1;
  }

  return new Promise(function(resolve, reject){
    function doResolve() {
      resolve({config: {
        options: options,
        builddir: builddir,
        sourceDir: options.contentdir,
        staticDir: options.staticdir,
        themeDir: options.themedir,
        articlesLocation: 'articles',
        redirectsLocation: 'redirects',
        linksPerPage: 6
      }});
    }
    doResolve();
  })
}
module.exports.watch = !options.noserver;
module.exports.themeDir = options.themedir;
