'use strict';
var toml = require('toml');
var path = require('path');

var readRedirectWorker = function(content, obj) {
  if(content === undefined) throw new Error('content is undefined');
  try {
    obj.metadata = toml.parse(content);
  } catch(e) {
    console.log(obj.filename+': Failed to parse metadata');
    throw e;
  }
  obj.content = obj.metadata.target;
  console.log(obj.file)
  obj.file = obj.file.split(path.sep).join('/');
  if(obj.file.match(/^redirects\/(.*)index\.toml/))
    obj.file = obj.file.replace(/^redirects\/(.*)index\.toml/,'$1');
  else
    obj.file = obj.file.replace(/^redirects\/(.*)\.toml/,'$1');
  console.log(obj.file)
  return obj;
}

module.exports = function(obj) {
  console.log('Build step: ParseRedirects');
  return new Promise(function(resolve, reject) {
    var redirects = [];
    obj.redirects.forEach(function(page) {
      redirects.push(readRedirectWorker(page.content, page));
    })
    obj.redirects = redirects;
    resolve(obj);
  });
}
